package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.Propinsi;
import com.jasamedika.medifirst2000.vo.PropinsiVO;

/**
 * Converter class between Pasien and PasienVO
 * 
 * @author Askur
 */
@Component
public class PropinsiConverter implements BaseVoConverter<PropinsiVO, Propinsi> {


	@Override
	public Propinsi transferVOToModel(PropinsiVO vo, Propinsi model) {
		if (null == model)
			model = new Propinsi();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, Propinsi.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return model;
	}

	@Override
	public List<PropinsiVO> transferListOfModelToListOfVO(List<Propinsi> models, List<PropinsiVO> vos) {

		if (null == vos)
			vos = new ArrayList<PropinsiVO>();

		if (null == models)
			return vos;

		for (Propinsi pegawai : models) {
			PropinsiVO vo = new PropinsiVO();
			vo=transferModelToVO(pegawai, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public PropinsiVO transferModelToVO(Propinsi model, PropinsiVO vo) {
		if (null == vo)
			vo = new PropinsiVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, PropinsiVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	
	
	

}
